#
# implement a stopwatch, which can be started and stopped
#
module Timeless
  module Stopwatch
    require 'date'
    
    def self.start start=nil, notes=nil
      store_start (start ? start : Time.now), (notes ? notes : "")
    end

    def self.stop start=nil, stop=nil, notes=nil
      if not start
        start, _ = get_start
      end

      if notes == nil or notes == ""
        _, notes = get_start
      end

      if not stop
        stop = Time.now
      end

      forget # forget started clock, if any

      [start, stop, notes]
    end

    #
    # Storing and retrieving start time and notes
    #
    # file containing the start time

    START_FILENAME = File.expand_path("~/.timeless-tmp.csv")

    def self.clocking?
      File.exists?(START_FILENAME) 
    end

    def self.get_start
      if clocking?
        array = CSV.read(START_FILENAME, "r")
        [array[0][0], array[0][1]]
      else
        [nil, nil]
      end
    end

    def self.store_start start, notes
      CSV.open(START_FILENAME, "w") do |csv|
        csv << [start, notes]
      end
    end

    # forget the start clock
    def self.forget
      File.delete(START_FILENAME) if File.exists?(START_FILENAME) 
    end

  end
end
